//+------------------------------------------------------------------+
//|                                                 OpenHedge EA.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int        Slippage=5;
extern int        MagicNumber_1=1000;
extern int        MagicNumber_2=2000;
extern string     Explanation1="After Above entered amount of Profit is Reached cumulatively in Orders with same magic Number, EA will close them all.";
//extern int        MagicNumber=1000;
//extern int       Slippage=3;

double dXPoint=1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if(Digits==3 || Digits==5)
     {
      dXPoint=10;
     }

   if(Digits==3 || Digits==5)
     {
      dXPoint=10;
      int SLIPPAGE=SLIPPAGE*dXPoint;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(OrdersTotal()>0)
      {
      startLookingForProfits(MagicNumber_1);
      startLookingForProfits(MagicNumber_2);
      }
   else
      startLookingForTrades();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int startLookingForTrades()
  {

   if(iMA(NULL,0,13,8,MODE_SMMA,PRICE_MEDIAN,0)<iMA(NULL,0,20,8,MODE_SMMA,PRICE_MEDIAN,0))
     {

      OrderSend("EURUSD",OP_BUY,1,MarketInfo("EURUSD",MODE_ASK),2,NULL,NULL,NULL,MagicNumber_1,0,CLR_NONE);

      Sleep(1000);

      OrderSend("USDCHF",OP_BUY,1,MarketInfo("USDCHF",MODE_ASK),2,NULL,NULL,NULL,MagicNumber_1,0,CLR_NONE);

      Sleep(1000);

      OrderSend("EURUSD",OP_SELL,1,MarketInfo("EURUSD",MODE_BID),2,NULL,NULL,NULL,MagicNumber_2,0,CLR_NONE);

      Sleep(1000);

      OrderSend("USDCHF",OP_SELL,1,MarketInfo("USDCHF",MODE_BID),2,NULL,NULL,NULL,MagicNumber_2,0,CLR_NONE);

      Sleep(1000);

      //RefreshRates();

     }

//------------- 2

   if(iMA(NULL,0,13,8,MODE_SMMA,PRICE_MEDIAN,0)>iMA(NULL,0,20,8,MODE_SMMA,PRICE_MEDIAN,0))

     {
      OrderSend("EURUSD",OP_SELL,1,MarketInfo("EURUSD",MODE_BID),2,NULL,NULL,NULL,MagicNumber_1,0,CLR_NONE);

      Sleep(1000);

      OrderSend("USDCHF",OP_SELL,1,MarketInfo("USDCHF",MODE_BID),2,NULL,NULL,NULL,MagicNumber_1,0,CLR_NONE);

      Sleep(1000);

      OrderSend("EURUSD",OP_BUY,1,MarketInfo("EURUSD",MODE_ASK),2,NULL,NULL,NULL,MagicNumber_2,0,CLR_NONE);

      Sleep(1000);

      OrderSend("USDCHF",OP_BUY,1,MarketInfo("USDCHF",MODE_ASK),2,NULL,NULL,NULL,MagicNumber_2,0,CLR_NONE);

      Sleep(1000);

      //RefreshRates();
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int startLookingForProfits(int MagicNumber)
  {
   int ProfitTarget=AccountBalance()*0.002;
   double dblProfit=0;
   int POS=0;
   bool boolTerm=false;
   while(boolTerm==false)
     {
      if(OrderSelect(POS,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==MagicNumber) dblProfit=dblProfit+OrderProfit();
         POS++;
        }
      else
         boolTerm=true;
     }
   if(dblProfit>=ProfitTarget)
     {
      for(int i=OrdersTotal()-1;i>=0;i--)
        {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderMagicNumber()==MagicNumber)
           {
            int type=OrderType();
            bool result=false;

            switch(type)
              {
               //Close opened long positions
               case OP_BUY  : 
                  result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Red);
               break;

               //Close opened short positions
               case OP_SELL : 
                  result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,LimeGreen);
               break;
              }

            if(result==false)
              {
               Sleep(0);
              }
           }
        }
      Print("Profit Target For MagicNumber based Trades Reached & They have been Closed");
      return(0);
     }

   Comment("AccountBalance: $",AccountBalance(),"\n",
           "Account Equity: $",AccountEquity(),"\n",
           "Profit Target MagicNo. Based Trades: $",ProfitTarget,"\n",
           "Current Profit MagicNo. Based Trades: $",dblProfit,"\n");

   return(0);
  }
//+------------------------------------------------------------------+

